package ch.fritteli.labyrinth.generator.serialization;

import ch.fritteli.labyrinth.generator.model.Labyrinth;
import java.io.ByteArrayOutputStream;
import lombok.NonNull;

public abstract class AbstractLabyrinthOutputStream extends ByteArrayOutputStream {

    public abstract void writeHeader();

    public abstract void writeLabyrinthData(@NonNull final Labyrinth labyrinth);

    public void writeByte(final byte value) {
        this.write(value);
    }

    public void writeInt(final int value) {
        this.write(value >> 24);
        this.write(value >> 16);
        this.write(value >> 8);
        this.write(value);
    }

    public void writeLong(final long value) {
        this.writeInt((int) (value >> 32));
        this.writeInt((int) value);
    }
}
