package ch.fritteli.labyrinth.generator.serialization.v1;

import ch.fritteli.labyrinth.generator.Generator;
import ch.fritteli.labyrinth.generator.model.Labyrinth;
import org.junit.jupiter.api.Test;

import static org.assertj.core.api.Assertions.assertThat;

class SerializerDeserializerV1Test {
    @Test
    void testSerializeDeserializeTiny() {
        final Labyrinth expected = new Labyrinth(2, 2, 255);
        new Generator(expected).run();
        final byte[] bytes = SerializerDeserializerV1.serialize(expected);
        final Labyrinth result = SerializerDeserializerV1.deserialize(bytes);
        assertThat(result).isEqualTo(expected);
    }

    @Test
    void testSerializeDeserializeMedium() {
        final Labyrinth expected = new Labyrinth(20, 20, -271828182846L);
        new Generator(expected).run();
        final byte[] bytes = SerializerDeserializerV1.serialize(expected);
        final Labyrinth result = SerializerDeserializerV1.deserialize(bytes);
        assertThat(result).isEqualTo(expected);
    }

    @Test
    void testSerializeDeserializeLarge() {
        final Labyrinth expected = new Labyrinth(200, 320, 3141592653589793238L);
        new Generator(expected).run();
        final byte[] bytes = SerializerDeserializerV1.serialize(expected);
        final Labyrinth result = SerializerDeserializerV1.deserialize(bytes);
        assertThat(result).isEqualTo(expected);
    }
}
